<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>JavaScript Functions</title>
</head>

<body>
    <script>
        // Variant 1
        function doSomething(param1, param2, param3 = 'Default Value 123') {
            console.log(param1);
            console.log(param2);
            console.log(param3);
        }

        // Variant 2
        let myLittleFunction = function (param1, param2, param3 = 'Default Value 123') {
            console.log(param1);
            console.log(param2);
            console.log(param3);
        }

        // Variant 3
        const myCoolArrowFunction = (param1, param2, param3 = 'Default Value 123') => {
            console.log(param1);
            console.log(param2);
            console.log(param3);
        }

        const mySimpleArrowFunction = () => console.log('I am a simple arrow function');
        const mySimpleArrowFunction2 = x => console.log('I am a simple arrow function: ' + x);
        const toCube = x => x * x * x;

        // doSomething('Foo', 'Bar', 'Marek');
        // myLittleFunction('Foo', 'Bar');
        // myCoolArrowFunction('Foo', 'Bar', 'ATATA');
        // mySimpleArrowFunction();
        // console.log(toCube(5));

        // Exercises

        // Ex 13
        function extractPersonBirthYear(personalCode) {
            let firstDigit = parseInt(personalCode.charAt(0));
            let birthYearDigits = parseInt(personalCode.substr(1, 2));
            switch (firstDigit) {
                case 1:
                case 2:
                    return 1800 + birthYearDigits;
                case 3:
                case 4:
                    return 1900 + birthYearDigits;
                case 5:
                case 6:
                    return 2000 + birthYearDigits;
                default:
                    return -1;
            }
        }

        // let personalCode = prompt('Sisesta oma isikukood:');
        // console.log(extractPersonBirthYear(personalCode));

        // Ex 14
        const extractPersonGender = personalCode => parseInt(personalCode.charAt(0)) % 2 === 0 ? 'F' : 'M';
        console.log('Gender: ' + extractPersonGender('481034'));

        // Ex 15
        function isPersonalCodeValid(personalCode) {
            if (!personalCode || personalCode.length !== 11) {
                return false;
            } 

            let digits = personalCode.split("").map(d => parseInt(d));
            let weights1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 1];

            let sum = 0;
            for (let i = 0; i < 10; i++) {
                sum = sum + weights1[i] * digits[i];
            }

            let checksum = sum % 11;
            if (checksum !== 10) {
                return checksum === digits[10];
            } else {
                let weights2 = [3, 4, 5, 6, 7, 8, 9, 1, 2, 3];

                sum = 0;
                for(let i = 0; i < 10; i++) {
                    sum = sum + weights2[i] * digits[i];
                }

                checksum = sum % 11;
                if (checksum === 10) {
                    return 0 === digits[10];
                } else {
                    return checksum === digits[10];
                }
            }
        }
    </script>
</body>

</html>